// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"gochassis/ent/chat"
	"gochassis/ent/chatroom"
	"gochassis/ent/profile"
	"strings"
	"time"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
)

// Chat is the model entity for the Chat schema.
type Chat struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// Text holds the value of the "text" field.
	Text string `json:"text,omitempty"`
	// Attachment holds the value of the "attachment" field.
	Attachment string `json:"attachment,omitempty"`
	// AttachmentType holds the value of the "attachment_type" field.
	AttachmentType string `json:"attachment_type,omitempty"`
	// FrontendUUID holds the value of the "frontend_uuid" field.
	FrontendUUID string `json:"frontend_uuid,omitempty"`
	// CreatedAt holds the value of the "created_at" field.
	CreatedAt time.Time `json:"created_at,omitempty"`
	// UpdatedAt holds the value of the "updated_at" field.
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// DeletedAt holds the value of the "deleted_at" field.
	DeletedAt time.Time `json:"deleted_at,omitempty"`
	// ReplyTo holds the value of the "reply_to" field.
	ReplyTo int `json:"reply_to,omitempty"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the ChatQuery when eager-loading is set.
	Edges           ChatEdges `json:"edges"`
	chat_room_chats *int
	profile_chats   *int
	selectValues    sql.SelectValues
}

// ChatEdges holds the relations/edges for other nodes in the graph.
type ChatEdges struct {
	// Profile holds the value of the profile edge.
	Profile *Profile `json:"profile,omitempty"`
	// ChatRoom holds the value of the chat_room edge.
	ChatRoom *ChatRoom `json:"chat_room,omitempty"`
	// ReplyToEdge holds the value of the reply_to_edge edge.
	ReplyToEdge *Chat `json:"reply_to_edge,omitempty"`
	// Replies holds the value of the replies edge.
	Replies []*Chat `json:"replies,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [4]bool
}

// ProfileOrErr returns the Profile value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ChatEdges) ProfileOrErr() (*Profile, error) {
	if e.loadedTypes[0] {
		if e.Profile == nil {
			// Edge was loaded but was not found.
			return nil, &NotFoundError{label: profile.Label}
		}
		return e.Profile, nil
	}
	return nil, &NotLoadedError{edge: "profile"}
}

// ChatRoomOrErr returns the ChatRoom value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ChatEdges) ChatRoomOrErr() (*ChatRoom, error) {
	if e.loadedTypes[1] {
		if e.ChatRoom == nil {
			// Edge was loaded but was not found.
			return nil, &NotFoundError{label: chatroom.Label}
		}
		return e.ChatRoom, nil
	}
	return nil, &NotLoadedError{edge: "chat_room"}
}

// ReplyToEdgeOrErr returns the ReplyToEdge value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ChatEdges) ReplyToEdgeOrErr() (*Chat, error) {
	if e.loadedTypes[2] {
		if e.ReplyToEdge == nil {
			// Edge was loaded but was not found.
			return nil, &NotFoundError{label: chat.Label}
		}
		return e.ReplyToEdge, nil
	}
	return nil, &NotLoadedError{edge: "reply_to_edge"}
}

// RepliesOrErr returns the Replies value or an error if the edge
// was not loaded in eager-loading.
func (e ChatEdges) RepliesOrErr() ([]*Chat, error) {
	if e.loadedTypes[3] {
		return e.Replies, nil
	}
	return nil, &NotLoadedError{edge: "replies"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Chat) scanValues(columns []string) ([]any, error) {
	values := make([]any, len(columns))
	for i := range columns {
		switch columns[i] {
		case chat.FieldID, chat.FieldReplyTo:
			values[i] = new(sql.NullInt64)
		case chat.FieldText, chat.FieldAttachment, chat.FieldAttachmentType, chat.FieldFrontendUUID:
			values[i] = new(sql.NullString)
		case chat.FieldCreatedAt, chat.FieldUpdatedAt, chat.FieldDeletedAt:
			values[i] = new(sql.NullTime)
		case chat.ForeignKeys[0]: // chat_room_chats
			values[i] = new(sql.NullInt64)
		case chat.ForeignKeys[1]: // profile_chats
			values[i] = new(sql.NullInt64)
		default:
			values[i] = new(sql.UnknownType)
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Chat fields.
func (c *Chat) assignValues(columns []string, values []any) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case chat.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			c.ID = int(value.Int64)
		case chat.FieldText:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field text", values[i])
			} else if value.Valid {
				c.Text = value.String
			}
		case chat.FieldAttachment:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field attachment", values[i])
			} else if value.Valid {
				c.Attachment = value.String
			}
		case chat.FieldAttachmentType:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field attachment_type", values[i])
			} else if value.Valid {
				c.AttachmentType = value.String
			}
		case chat.FieldFrontendUUID:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field frontend_uuid", values[i])
			} else if value.Valid {
				c.FrontendUUID = value.String
			}
		case chat.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[i])
			} else if value.Valid {
				c.CreatedAt = value.Time
			}
		case chat.FieldUpdatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[i])
			} else if value.Valid {
				c.UpdatedAt = value.Time
			}
		case chat.FieldDeletedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field deleted_at", values[i])
			} else if value.Valid {
				c.DeletedAt = value.Time
			}
		case chat.FieldReplyTo:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field reply_to", values[i])
			} else if value.Valid {
				c.ReplyTo = int(value.Int64)
			}
		case chat.ForeignKeys[0]:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for edge-field chat_room_chats", value)
			} else if value.Valid {
				c.chat_room_chats = new(int)
				*c.chat_room_chats = int(value.Int64)
			}
		case chat.ForeignKeys[1]:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for edge-field profile_chats", value)
			} else if value.Valid {
				c.profile_chats = new(int)
				*c.profile_chats = int(value.Int64)
			}
		default:
			c.selectValues.Set(columns[i], values[i])
		}
	}
	return nil
}

// Value returns the ent.Value that was dynamically selected and assigned to the Chat.
// This includes values selected through modifiers, order, etc.
func (c *Chat) Value(name string) (ent.Value, error) {
	return c.selectValues.Get(name)
}

// QueryProfile queries the "profile" edge of the Chat entity.
func (c *Chat) QueryProfile() *ProfileQuery {
	return NewChatClient(c.config).QueryProfile(c)
}

// QueryChatRoom queries the "chat_room" edge of the Chat entity.
func (c *Chat) QueryChatRoom() *ChatRoomQuery {
	return NewChatClient(c.config).QueryChatRoom(c)
}

// QueryReplyToEdge queries the "reply_to_edge" edge of the Chat entity.
func (c *Chat) QueryReplyToEdge() *ChatQuery {
	return NewChatClient(c.config).QueryReplyToEdge(c)
}

// QueryReplies queries the "replies" edge of the Chat entity.
func (c *Chat) QueryReplies() *ChatQuery {
	return NewChatClient(c.config).QueryReplies(c)
}

// Update returns a builder for updating this Chat.
// Note that you need to call Chat.Unwrap() before calling this method if this Chat
// was returned from a transaction, and the transaction was committed or rolled back.
func (c *Chat) Update() *ChatUpdateOne {
	return NewChatClient(c.config).UpdateOne(c)
}

// Unwrap unwraps the Chat entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (c *Chat) Unwrap() *Chat {
	_tx, ok := c.config.driver.(*txDriver)
	if !ok {
		panic("ent: Chat is not a transactional entity")
	}
	c.config.driver = _tx.drv
	return c
}

// String implements the fmt.Stringer.
func (c *Chat) String() string {
	var builder strings.Builder
	builder.WriteString("Chat(")
	builder.WriteString(fmt.Sprintf("id=%v, ", c.ID))
	builder.WriteString("text=")
	builder.WriteString(c.Text)
	builder.WriteString(", ")
	builder.WriteString("attachment=")
	builder.WriteString(c.Attachment)
	builder.WriteString(", ")
	builder.WriteString("attachment_type=")
	builder.WriteString(c.AttachmentType)
	builder.WriteString(", ")
	builder.WriteString("frontend_uuid=")
	builder.WriteString(c.FrontendUUID)
	builder.WriteString(", ")
	builder.WriteString("created_at=")
	builder.WriteString(c.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(c.UpdatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("deleted_at=")
	builder.WriteString(c.DeletedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("reply_to=")
	builder.WriteString(fmt.Sprintf("%v", c.ReplyTo))
	builder.WriteByte(')')
	return builder.String()
}

// Chats is a parsable slice of Chat.
type Chats []*Chat
